--- sys/cddl/contrib/opensolaris/uts/common/fs/zfs/zfs_vnops.c.orig	2011-08-01 23:04:07.358173627 +0400
+++ sys/cddl/contrib/opensolaris/uts/common/fs/zfs/zfs_vnops.c		2011-08-02 00:10:02.674585604 +0400
@@ -618,7 +618,8 @@ zfs_read(vnode_t *vp, uio_t *uio, int io
 	/*
 	 * If we're in FRSYNC mode, sync out this znode before reading it.
 	 */
-	if (ioflag & FRSYNC || zfsvfs->z_os->os_sync == ZFS_SYNC_ALWAYS)
+	if (zfsvfs->z_log &&
+	    (ioflag & FRSYNC || zfsvfs->z_os->os_sync == ZFS_SYNC_ALWAYS))
 		zil_commit(zfsvfs->z_log, zp->z_id);
 
 	/*

